异常体系 异常的处理 Objects类中的静态方法 异常处理 自定义异常类与练习 多线程 线程的创建

2147-魏同学

发表文章数:26

热门标签

首页 » Java » 正文

异常:
指的是程序在执行过程中,出现的非正常情况,最终会导致JVM的非正常停止
Java中异常的处理是中断处理

java.lang.Throwable:类是 Java 语言中所有错误或异常的超类。
Exception:编译期异常,进行编译(写代码)java程序出现的问题
RuntimeException:运行期异常,java程序运行过程中出现的问题
异常就相当于程序得了一个小毛病(感冒,发烧),把异常处理掉,程序可以继续执行(吃点药,继续革命工作)
Error:错误
错误就相当于程序得了一个无法治愈的毛病(非典,艾滋).必须修改源代码,程序才能继续执行

import java.text.ParseException;
import java.text.SimpleDateFormat;
import java.util.Date;

public class Demo01Exception {
    public static void main(String[] args)/* throws ParseException抛出异常*/ {
/*        Exception:编译期异常,进行编译(写代码)java程序出现的问题
        SimpleDateFormat sdf = new SimpleDateFormat("yyyy-MM-dd");//用来格式化日期
        Date date = null;
        try {
            date = sdf.parse("1999-02-10");
        } catch (ParseException e) {
            e.printStackTrace();
        }
        System.out.println(date);//Wed Feb 10 00:00:00 GMT+08:00 1999*/


        //RuntimeException:运行期异常,java程序运行过程中出现的问题
       /* int[] arr = {1,2,3};
        try {
            //可能会出现异常的代码
            System.out.println(arr[3]);
        } catch (Exception e) {
            //异常的处理逻辑
            System.out.println(e);//java.lang.ArrayIndexOutOfBoundsException: 3
        }
        System.out.println("后续代码");可以执行*/

        /*
        *   Error:错误
        *       OutOfMemoryError:Java heap space
        *       内存溢出错误,创建的数组太大了,超出了给JVM分配的内存
        *   */
        int [] arr = new int[123*81151*1024];//OutOfMemoryError 错误必须修该源代码 让创建的数组小一些
        
    }
}

异常的产生过程解析(分析异常是怎么产生的,如何处理异常)

public class Demo02Exception {
    public static void main(String[] args) {
        //创建int类型的数组,并赋值
        int[] arr ={1,2,3};
        int e = getElement(arr,3);
        System.out.println(e);//ArrayIndexOutOfBoundsException: 3

    }

    /*
    *   定义一个方法,获取数组指定索引处的元素
    *   参数:
    *       int arr
    *       int index*/

    public static int getElement(int [] arr,int index){
        int ele = arr[index];
        return ele;

    }
}

原理:
异常体系 异常的处理 Objects类中的静态方法 异常处理 自定义异常类与练习 多线程 线程的创建

异常处理:

  • throw关键字
  • 作用:
  •   可以使用throw关键字在指定的方法中抛出指定的异常
    
  • 使用格式:
  •   throw new Exception("异常产生的原因")
    
  • 注意:
  •   1 throw关键字必须写在方法内部
    
  •   2 throw关键字后边new的对象必须是Exception或者Exception的子类
    
  •   3 throw关键字抛出指定的异常对象,我们必须处理这个异常对象
    
  •       throw关键字后面创建的是RunTimeException或者是 RunTimeException子类对象,我们可以不处理,默认交给JVM处理(打印异常对象,中断程序)
    
  •       throw关键字关键字后边创建的是编译异常(写代码的时候报错),我们就必须处理这个异常,要么throws,要么try..catch
    
public class Demo03Throw {
    public static void main(String[] args) {
        //int [] arr = null;
        int[] arr = new int [3];
        int d =getElement(arr,3);
//        System.out.println(e);//NullPointerException: 传递的数组的值是null
        System.out.println(d);//ArrayIndexOutOfBoundsException: 传递的索引超出了数组的使用范围
    }


    /*
     *   定义一个方法,获取数组指定索引处的元素
     *   参数:
     *       int arr
     *       int index
          以后,我们首先必须对方法传递过来的参数进行合法性的校验
           如果参数不合法,那我们就必须使用抛出异常的方式,告知方法的调用者,传递的参数有问题
          注意:NullPointerException是一个运行期异常,我们不用处理,默认交给JVM处理
     */


    public static int getElement(int[] arr, int index) {
        /*
        * 我们可以对传递过来的参数数组,进行合法性校验
        * 如果数组arr的值是null
        * 那么我们就抛出空指针异常,告知方法的调用者"传递的数组的值是null"
        * */
        if (arr == null){
            throw new NullPointerException("传递的数组的值是null");
        }

        /*
        * 我们可以对传递过来的参数index进行合法校验
        * 如果index的范围不在数组的索引范围内
        * 那么我们就抛出数组越界异常,告知方法的调用者"传递的索引超出了数组的使用范围"*/
        if(index < 0 || index > arr.length-1){
            throw new ArrayIndexOutOfBoundsException("传递的索引超出了数组的使用范围");

        }

        int ele = arr[index];
        return ele;

    }

}

Objects类中的静态方法

可以使用objects中的requireNonNull方法,判断是否为空,简化书写

Objects类中的静态方法
public static  T requireNonNull(T obj):查看指定引用对象不是null。
源码:
    public static  T requireNonNull(T obj) {
        if (obj == null)
            throw new NullPointerException();
        return obj;
    }
import java.util.Objects;

public class Demo04Objects {
    public static void main(String[] args) {
        method(null);
    }

    public static void method(Object obj){
       /* if(obj == null){
            throw new NullPointerException("传递对象的值是null");
        }*/

//        Objects.requireNonNull(obj);//NullPointerException
        Objects.requireNonNull(obj,"传递的对象是null");
    }
}

throws关键字:异常处理的第一种方式,交给别人处理
作用:
当方法内部抛出异常对象的时候,那么我们就必须处理这个异常对象
可以使用throws关键字处理异常对象,会把异常对象声明抛出给方法的调用者处理(自己不处理,给别人处理),
最终交给JVM处理–>中断处理

使用格式:在方法声明时使用
修饰符 返回值类型 方法名(参数列表) throws AAAExcepiton,BBBExcepiton…{
throw new AAAExcepiton(“产生原因”);
throw new BBBExcepiton(“产生原因”);

}
注意:
1.throws关键字必须写在方法声明处
2.throws关键字后边声明的异常必须是Exception或者是Exception的子类
3.方法内部如果抛出了多个异常对象,那么throws后边必须也声明多个异常
如果抛出的多个异常对象有子父类关系,那么直接声明父类异常即可
4.调用了一个声明抛出异常的方法,我们就必须的处理声明的异常
要么继续使用throws声明抛出,交给方法的调用者处理,最终交给JVM
要么try…catch自己处理异常

public class Demo05Throws {

    /*
    FileNotFoundException extends IOException extends Excepiton
    如果抛出的多个异常对象有子父类关系,那么直接声明父类异常即可
 */
    public static void main(String[] args) throws /*FileNotFoundException*/IOException {
    readFile("d://a.tet");
    }


       /* 定义一个方法,对传递的文件路径进行合法性判断
        如果路径不是"c://a.txt",那么我们就抛出文件找不到异常对象,告知方法的调用者
        注意:
            FileNotFoundException是编译异常,抛出了编译异常,就必须处理这个异常
            可以使用throws继续声明抛出FileNotFoundException这个异常对象,让方法的调用者处理
       */

    public static void readFile(String fileName) throws FileNotFoundException,IOException {
        if(!fileName.equals("c://a.txt") ){
            throw new FileNotFoundException("传递的路径不是c://a.txt");
        }

        /*
        *   如果传递的路径不是txt结尾
        *   那么我们就抛出IO异常对象,告知方法的调用者,文件的后缀名不对*/

        if (!fileName.endsWith("txt")){
            throw new IOException("文件的后缀名不对");
        }
        System.out.println("没问题");
    }
}

try…catch:异常处理的第二种方式,自己处理异常
格式:
try{
可能产生异常的代码
}catch(定义一个异常的变量,用来接收try中抛出的异常对象){
异常的处理逻辑,异常异常对象之后,怎么处理异常对象
一般在工作中,会把异常的信息记录到一个日志中
}

catch(异常类名 变量名){
}
注意:
1.try中可能会抛出多个异常对象,那么就可以使用多个catch来处理这些异常对象
2.如果try中产生了异常,那么就会执行catch中的异常处理逻辑,执行完毕catch中的处理逻辑,继续执行try…catch之后的代码
如果try中没有产生异常,那么就不会执行catch中异常的处理逻辑,执行完try中的代码,继续执行try…catch之后的代码

import java.io.IOException;

public class Demo06TryCatch {
    public static void main(String[] args) {
        try{
            readFile("d://a.txt");

        }catch (IOException e){//try中抛出什么异常对象,catch就定义什么异常变量,用来接收这个异常对象
//            异常的处理逻辑,异常异常对象之后,怎么处理异常对象
            System.out.println("catch-传递文件后缀不是.txt");
            
 /*
                Throwable类中定义了3个异常处理的方法
                 String getMessage() 返回此 throwable 的简短描述。
                 String toString() 返回此 throwable 的详细消息字符串。
                 void printStackTrace()  JVM打印异常对象,默认此方法,打印的异常信息是最全面的
             */
//            System.out.println(e.getMessage());//文件的后缀名不对
//            System.out.println(e.toString());//java.io.IOException: 文件的后缀名不对
//            System.out.println(e);//java.io.IOException: 文件的后缀名不对

            e.printStackTrace();
            /*java.io.IOException: 文件的后缀名不对
            at com.itheima.day05.Demo06TryCatch.readFile(Demo06TryCatch.java:58)
            at com.itheima.day05.Demo06TryCatch.main(Demo06TryCatch.java:27)*/


        }
        System.out.println("后续代码");

    }

    /*
       如果传递的路径,不是.txt结尾
       那么我们就抛出IO异常对象,告知方法的调用者,文件的后缀名不对

    */
    public static void readFile(String fileName) throws IOException  {

        if (!fileName.endsWith(".txt")) {
            throw new IOException("文件的后缀名不对");
        }

        System.out.println("路径没有问题,读取文件");
    }
}

finally代码块
格式:
try{
可能产生异常的代码
}catch(定义一个异常的变量,用来接收try中抛出的异常对象){
异常的处理逻辑,异常异常对象之后,怎么处理异常对象
一般在工作中,会把异常的信息记录到一个日志中
}

catch(异常类名 变量名){
}finally{
无论是否出现异常都会执行
}
注意:
1.finally不能单独使用,必须和try一起使用
2.finally一般用于资源释放(资源回收),无论程序是否出现异常,最后都要资源释放(IO)

public class Demo07TryCatchFinally {

    public static void main(String[] args) {
        try {
            //可能会产生异常的代码
            readFile("c://a.ttxt");
        } catch (IOException e) {
            //异常处理逻辑
            e.printStackTrace();
        } finally {
            //无论是否出现异常,都会执行
            System.out.println("资源释放");
        }

    }

    public static void readFile(String fileName) throws IOException {

        if(!fileName.endsWith(".txt")){
            throw new IOException("文件的后缀名不对");
        }

        System.out.println("路径没有问题,读取文件");
    }
}

异常注意事项

import java.util.List;

public class Demo08Exception {
    public static void main(String[] args) {
            /*
            多个异常使用捕获又该如何处理呢?
            1. 多个异常分别处理。
            2. 多个异常一次捕获,多次处理。
            3. 多个异常一次捕获一次处理。
         */
//        1. 多个异常分别处理。
      /*  try{
            int [] arr ={1,2,3};
            System.out.println(arr[3]);//ArrayIndexOutOfBoundsException

        }catch (ArrayIndexOutOfBoundsException e){
        System.out.println(e);
        }

        try {
            List list = List.of(1,2,4);
            System.out.println(list.get(3));//IndexOutOfBoundsException: Index 3 out-of-bounds for length 3
        }catch (IndexOutOfBoundsException e){
            System.out.println(e);
        }*/

//        2. 多个异常一次捕获,多次处理。

       /* try {
            int [] arr ={1,2,3};
//            System.out.println(arr[3]);//ArrayIndexOutOfBoundsException
            List list = List.of(1,2,4);
            System.out.println(list.get(3));//IndexOutOfBoundsException: Index 3 out-of-bounds for length 3
        }catch (ArrayIndexOutOfBoundsException e){
            System.out.println(e);
        }catch (IndexOutOfBoundsException e){
            System.out.println(e);
        }
        */

          /*
            一个try多个catch注意事项:
                catch里边定义的异常变量,如果有子父类关系,那么子类的异常变量必须写在上边,否则就会报错
                ArrayIndexOutOfBoundsException extends IndexOutOfBoundsException
         */

//        3. 多个异常一次捕获一次处理。
        try {
            int [] arr ={1,2,3};
//            System.out.println(arr[3]);//ArrayIndexOutOfBoundsException
            List<Integer> list = List.of(1,2,4);
            System.out.println(list.get(3));//IndexOutOfBoundsException: Index 3 out-of-bounds for length 3
        } catch (Exception e){
            System.out.println(e);
        }

        //运行时异常被抛出可以不处理。即不捕获也不声明抛出。
        //默认给虚拟机处理,终止程序,什么时候不抛出运行时异常了,在来继续执行程序
        int[] arr = {1,2,3};
        System.out.println(arr[3]);//ArrayIndexOutOfBoundsException: 3
        List<Integer> list = List.of(1, 2, 3);
        System.out.println(list.get(3));//IndexOutOfBoundsException: Index 3 out-of-bounds for length 3


        System.out.println("后续代码");
    }
}

如果finally有return语句,永远返回finally中的结果,避免该情况.

public class Demo09Exception {
    public static void main(String[] args) {
        int a = getA();
        System.out.println(a);//100
    }

    //定义一个方法,返回变量a的值
    public static int getA() {
        int a = 10;
        try {
            return a;
        } catch (Exception e) {
            System.out.println(e);
        } finally {
            //一定会执行的代码
            a = 100;
            return a;
        }
    }
}

子父类的异常:
– 如果父类抛出了多个异常,子类重写父类方法时,抛出和父类相同的异常或者是父类异常的子类或者不抛出异常。
– 父类方法没有抛出异常,子类重写父类该方法时也不可抛出异常。此时子类产生该异常,只能捕获处理,不能声明抛出
注意:
父类异常时什么样,子类异常就什么样

public class Fu {
    public void show01() throws NullPointerException,ClassCastException{}
    public void show02() throws IndexOutOfBoundsException{}
    public void show03() throws IndexOutOfBoundsException{}
    public void show04()  {}
}
    
    class zi extends Fu{
    //子类重写父类方法时,抛出和父类相同的异常
        public void show01() throws NullPointerException,ClassCastException{}
    //子类重写父类方法时,抛出父类异常的子类
        public void show02() throws ArrayIndexOutOfBoundsException{}
    //子类重写父类方法时,不抛出异常
        public void show03(){}
    //父类方法没有抛出异常,子类重写父类该方法时也不可抛出异常
//        public void show04()  {}

    //    子类产生该异常,只能捕获处理,不能声明抛出,只能try...catch
        public void show04()  {
            try {
                throw new Exception("异常");
            } catch (Exception e) {
                e.printStackTrace();
            }
        }
    
    }

自定义异常类:
java提供的异常类,不够我们使用,需要自己定义一些异常类
格式:
public class XXXExcepiton extends Exception | RuntimeException{
添加一个空参数的构造方法
添加一个带异常信息的构造方法
}
注意:
1.自定义异常类一般都是以Exception结尾,说明该类是一个异常类
2.自定义异常类,必须的继承Exception或者RuntimeException继承Exception:那么自定义的异常类就是一个编译期异常,如果方法内部抛出了编译期异常,就必须处理这个异常,要么throws,要么try…catch
继承RuntimeException:那么自定义的异常类就是一个运行期异常,无需处理,交给虚拟机处理(中断处理)

public class RegisterException extends Exception {
    //添加一个空参数的构造方法
    public RegisterException(){
        super();
    }
    //添加一个带异常信息的构造方法
    //查看源码发现,所有的异常类都会有一个带异常信息的构造方法,方法内部会调用父类带异常信息的构造方法,让父类来处理这个异常信息
    public RegisterException(String message){
        super(message);
    }
}
/*
    要求:我们模拟注册操作,如果用户名已存在,则抛出异常并提示:亲,该用户名已经被注册。

    分析:
        1.使用数组保存已经注册过的用户名(数据库)
        2.使用Scanner获取用户输入的注册的用户名(前端,页面)
        3.定义一个方法,对用户输入的中注册的用户名进行判断
            遍历存储已经注册过用户名的数组,获取每一个用户名
            使用获取到的用户名和用户输入的用户名比较
                true:
                    用户名已经存在,抛出RegisterException异常,告知用户"亲,该用户名已经被注册";
                false:
                    继续遍历比较
            如果循环结束了,还没有找到重复的用户名,提示用户"恭喜您,注册成功!";
 */
public class Demo01RegisterException {
    // 1.使用数组保存已经注册过的用户名(数据库)
    static String[] usernames ={"张三","李四","王五"};

    public static void main(String[] args) /*throws RegisterException*/ {
        //2.使用Scanner获取用户输入的注册的用户名(前端,页面)
        Scanner sc = new Scanner(System.in);
        System.out.println("请输入名字:");
        String username = sc.next();
        checkUserName(username);

    }
//    3.定义一个方法,对用户输入的中注册的用户名进行判断
    public static void checkUserName(String username) /*throws RegisterException*/ {
        //遍历存储已经注册过用户名的数组,获取每一个用户名
        for (String name : usernames) {
            //使用获取到的用户名和用户输入的用户名比较
            if (name.equals(username)){
                try {
                    throw new RegisterException("亲,该用户名已经被注册");
                } catch (RegisterException e) {
                    e.printStackTrace();
                    return;//结束方法 不会往下运行
                }
            }

        }
        System.out.println("恭喜您,注册成功!");
    }

}
public class Demo02RegisterException {
    // 1.使用数组保存已经注册过的用户名(数据库)
    static String[] usernames ={"张三","李四","王五"};

    public static void main(String[] args) /*throws RegisterException*/ {
        //2.使用Scanner获取用户输入的注册的用户名(前端,页面)
        Scanner sc = new Scanner(System.in);
        System.out.println("请输入名字:");
        String username = sc.next();
        checkUserName(username);

    }
    //    3.定义一个方法,对用户输入的中注册的用户名进行判断
    public static void checkUserName(String username) /*throws RegisterException*/ {
        //遍历存储已经注册过用户名的数组,获取每一个用户名
        for (String name : usernames) {
            //使用获取到的用户名和用户输入的用户名比较
            if (name.equals(username)){
               throw new RegisterException("亲,该用户名已经被注册");//抛出运行期异常,无需处理,交给JVM处理,中断处理
            }

        }
        System.out.println("恭喜您,注册成功!");
    }

}

多线程:
并发:指两个或多个事件在同一时间段发生
并行:指两个或多个事件在同一时刻发生(同时发生)
异常体系 异常的处理 Objects类中的静态方法 异常处理 自定义异常类与练习 多线程 线程的创建
**进程:**是指内存中运行的应用程序,应用程序进入到内存中执行
异常体系 异常的处理 Objects类中的静态方法 异常处理 自定义异常类与练习 多线程 线程的创建
**线程:**线程是进程的一个执行单元,负责当前进程中程序的执行,一个进程中至少有一个线程。一个进程中可以有多个线程,这个应用程序也可以称之为多线程程序
异常体系 异常的处理 Objects类中的静态方法 异常处理 自定义异常类与练习 多线程 线程的创建
线程调度
1 分时调度 平均分配占用CPU的时间
2 抢占式调度 看优先级 优先级高的执行的机率就高

主线程
主线程:执行主(main)方法的线程
单线程程序:java程序中只有一个线程
执行从main方法开始,从上到下依次执行

JVM执行main方法,main方法会进入到栈内存
JVM会找操作系统开辟一条main方法通向cpu的执行路径
cpu就可以通过这个路径来执行main方法
而这个路径有一个名字,叫main(主)线程

public class Demo01MainThread {

    public static void main(String[] args) {
        Person p1 = new Person("w");
        p1.run();
        System.out.println(0/0);//出现异常,不能执行后续的代码 ArithmeticException 单线程
        Person p2 = new Person("Z");
        p2.run();
    }
}
public class Person {
        private String name;

        public void run(){
            //定义循环,执行20次
            for(int i=0; i<20; i++){
                System.out.println(name+"-->"+i);
            }
        }

        public Person() {
        }

        public Person(String name) {
            this.name = name;
        }

        public String getName() {
            return name;
        }

        public void setName(String name) {
            this.name = name;
        }
}

异常体系 异常的处理 Objects类中的静态方法 异常处理 自定义异常类与练习 多线程 线程的创建
创建多线程:
创建多线程程序的第一种方式:创建Thread类的子类
java.lang.Thread类:是描述线程的类,我们想要实现多线程程序,就必须继承Thread类

实现步骤:
1.创建一个Thread类的子类
2.在Thread类的子类中重写Thread类中的run方法,设置线程任务(开启线程要做什么?)
3.创建Thread类的子类对象
4.调用Thread类中的方法start方法,开启新的线程,执行run方法
void start() 使该线程开始执行;Java 虚拟机调用该线程的 run 方法。
结果是两个线程并发地运行;当前线程(main线程)和另一个线程(创建的新线程,执行其 run 方法)。
多次启动一个线程是非法的。特别是当线程已经结束执行后,不能再重新启动。
java程序属于抢占式调度,哪个线程的优先级高,哪个线程优先执行;同一个优先级,随机选择一个执行
例:

public class Demo01Thread {
    public static void main(String[] args) {
//        3.创建Thread类的子类对象
        MyThread mt = new MyThread();
//        4.调用Thread类中的方法start方法,开启新的线程,执行run方法
        mt.start();
        for (int i = 0; i < 20; i++) {
            System.out.println("main" + i);
        }
    }

}
public class MyThread extends Thread{
//    2.在Thread类的子类中重写Thread类中的run方法,设置线程任务(开启线程要做什么?)

    @Override
    public void run() {
        for (int i = 0; i < 20; i++) {
            System.out.println("run" + i);
        }
    }
}
标签:
分享到:
赞(0) 打赏

评论 抢沙发

评论前必须登录!

  注册



长按图片转发给朋友

觉得文章有用就打赏一下文章作者

支付宝扫一扫打赏

微信扫一扫打赏

Vieu3.3主题
专业打造轻量级个人企业风格博客主题!专注于前端开发,全站响应式布局自适应模板。

登录

忘记密码 ?

您也可以使用第三方帐号快捷登录

Q Q 登 录
微 博 登 录